//============================================================================
// MapVoteAdminMessages
//============================================================================
//
class MapVoteAdminMessages extends Info config(MapVoteXM);
//
var(Maps) config string Message[100];

var bool bInitialized;

function PostBeginPlay ()
{
    Super.PostBeginPlay();

    if ( !bInitialized )
    {
       bInitialized = true;
       SaveConfig();
    }
}

function SaveAdminMessage(string PlayerName, string sMesg)
{
    local string sTemp;
    local int i;

    sTemp = GetAbsoluteDate()$" - ";

    for (i=0; i<100; i++)
    {
        if (Message[i] == "")
        {
            Message[i] = sTemp$PlayerName$" Says: "$sMesg;
            SaveConfig();
            break;
        }
    }
    if (i == 100)
    {
       for (i=0; i<99; i++)
       {
            Message[i] = Message[i+1];
       }
       Message[99] = sTemp$PlayerName$" Says: "$sMesg;
       SaveConfig();
    }
}

function DeleteMessages()
{
    local int i;

    for (i=0; i<100; i++)
    {
        Message[i] = "";
    }
    SaveConfig();
}

function string GetAbsoluteDate()
{
	local string AbsoluteDate;

	AbsoluteDate = string(Level.Year);

	if (Level.Month < 10)
		AbsoluteDate = AbsoluteDate$"/0"$Level.Month;
	else
		AbsoluteDate = AbsoluteDate$"/"$Level.Month;

	if (Level.Day < 10)
		AbsoluteDate = AbsoluteDate$"/0"$Level.Day;
	else
		AbsoluteDate = AbsoluteDate$"/"$Level.Day;

    return AbsoluteDate;
}
//
defaultproperties
{
}
