//============================================================================
// MapVoteDefaultSwitch
//============================================================================
//
class MapVoteDefaultSwitch extends Info;
//
var() MapVoteX MyMut;

var int ServerSwitchMins;
var int ServerEmptyTime;

function PostBeginPlay()
{
	Super.PostBeginPlay();
	ServerEmptyTime = 0;
	SetTimer(60.00,false);
}

event Timer()
{
	if ( Level.Game.NumPlayers == 0 )
	{
		if ( ServerEmptyTime++ >= ServerSwitchMins )
		{
			MyMut.HandleDefaultSwitch();
			ServerEmptyTime = 0;
			return;
		}
	}
	else
	{
		ServerEmptyTime=0;
	}
	SetTimer(60.00,false);
}
//
defaultproperties
{
}
