//=================================================================
// MapVoteServerNames
//=================================================================
//
class MapVoteServerNames extends Info config(MapVoteX);
//
var MapVoteX MyMut;

struct ServerNames
{
	var bool   bUse;
	var string ServerName;
};

var() config ServerNames ServerName[30];

var bool bInitialized;

function PostBeginPlay()
{
    if (!bInitialized)
    {
       bInitialized = true;
       SaveConfig();
    }
    Super.PostBeginPlay();
}

function DoServerName(int iGame)
{
    if (ServerName[iGame].bUse && ServerName[iGame].ServerName != "")
    {
        class'Engine.GameReplicationInfo'.default.ServerName = ServerName[iGame].ServerName;
        class'Engine.GameReplicationInfo'.static.StaticSaveConfig();
    }
}
//
defaultproperties
{
}

