//================================================================================
// MapVoteInfoWindow.
//================================================================================
class MapVoteWindowInfo extends UWindowPageWindow;
//
#exec texture IMPORT NAME=mvx1 File=Textures\mvxtx.pcx GROUP=Mapvote MIPS=OFF

var color WhiteColor, GrayColor;

var UMenuLabelControl  lblKeyBind;

var UMenuLabelControl  lblVoteKey;
var UMenuRaisedButton  ButVoteKey;

var UMenuLabelControl   lblSmartKey;
var UMenuRaisedButton   ButSmartKey;

var UMenuLabelControl  LabelMesg;
var MapVoteEditControl AdmMessage;
var UWindowSmallButton SendButton;

var UWindowSmallButton QuitButton;
var MapVoteSmallButton BookButton;
var UWindowSmallButton CloseButton;

var MapVoteSmallButton SiteButton;

var string RealKeyName[255];
var string OldVoteKey;
var string OldSmartKey;
var bool bVote;
var bool bSmart;

var string Version;
var string sCode;

var string Servername;
var string ServerPort;
var string ServerIP;

var MapVoteGRI MVGRI;
var int  TickTock;

function Created ()
{
	Super.Created();

    SiteButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',130, 160, 140, 20));
	SiteButton.DownSound=Sound'GlassTink1';
	SiteButton.Text="";
	SiteButton.bDisabled=True;

    lblKeyBind = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 165, 225, 100, 16));
    lblKeyBind.SetText("");
    lblKeyBind.TextColor = WhiteColor;
    lblKeyBind.SetFont(F_Bold);

    lblVoteKey = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 18, 205, 130, 16));
    lblVoteKey.TextColor = WhiteColor;
    lblVoteKey.SetText("Bind  MapVote  Menu");
    lblVoteKey.SetFont(F_Bold);

    ButVoteKey = UMenuRaisedButton(CreateControl(class'UMenuRaisedButton', 15, 220, 110, 1));
    ButVoteKey.bAcceptsFocus = False;
    ButVoteKey.Align = TA_Center;
    ButVoteKey.bIgnoreLDoubleClick = True;
    ButVoteKey.bIgnoreMDoubleClick = True;
    ButVoteKey.bIgnoreRDoubleClick = True;

    lblSmartKey = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 272, 205, 130, 16));
    lblSmartKey.TextColor = WhiteColor;
    lblSmartKey.SetText("Bind  SmartDM  Menu");
    lblSmartKey.SetFont(F_Bold);

    ButSmartKey = UMenuRaisedButton(CreateControl(class'UMenuRaisedButton', 270, 220, 110, 1));
    ButSmartKey.bAcceptsFocus = False;
    ButSmartKey.Align = TA_Center;
    ButSmartKey.bIgnoreLDoubleClick = True;
    ButSmartKey.bIgnoreMDoubleClick = True;
    ButSmartKey.bIgnoreRDoubleClick = True;

    LabelMesg = UMenuLabelControl(CreateControl(class'UMenuLabelControl', 135, 245, 240, 16));
    LabelMesg.SetText("Send the Admin a Message");
    LabelMesg.TextColor = GrayColor;

	SendButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 325, 260, 55, 20));
	SendButton.DownSound=Sound'GlassTink1';
	SendButton.Text="Send";
	SendButton.bDisabled=False;                                  // horzpos,vertpos,width,height

    QuitButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 15, 295, 110, 20));
	QuitButton.DownSound=Sound'GlassTink1';
	QuitButton.Text="Quit Game";
	QuitButton.bDisabled=False;

    BookButton=MapVoteSmallButton(CreateControl(Class'MapVoteSmallButton',140, 295, 115, 20));
	BookButton.DownSound=Sound'GlassTink1';
	BookButton.Text="Add to Favorites";
	BookButton.bDisabled=True;

    CloseButton=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 270, 295, 110, 20));
	CloseButton.DownSound=Sound'Reload';
	CloseButton.Text="Close";
	CloseButton.bDisabled=False;

    LoadExistingKeys();

    // must go last
	AdmMessage=MapVoteEditControl(CreateControl(Class'MapVoteEditControl', 15, 260, 300, 16));
	AdmMessage.SetNumericOnly(False);
	AdmMessage.SetMaxLength(80);
	AdmMessage.SetValue("");
	AdmMessage.Align=TA_Left;
    AdmMessage.MVInfo = self;

    SetAcceptsFocus();
}

function Tick(float DeltaTime)
{
    if (TickTock++ == 10)
    {
        //Disable('Tick');
        if (sCode == "")
        {
           if ( MVGRI == none )
           {
              foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
              break;
           }
           sCode = MVGRI.sCode;
        }
    }
}

function Notify (UWindowDialogControl C, byte E)
{
    local string sTemp;

    Super.Notify(C,E);

    Switch(E)
    {
	  case DE_Click:
	  switch(C)
      {
      case SiteButton:
           sTemp = "http://www.proasm.com";
           GetPlayerOwner().ConsoleCommand("start "$sTemp);
           ParentWindow.ParentWindow.Close();
           break;
      case ButVoteKey:
           bVote = True;
           bSmart = False;
           ButVoteKey.bDisabled = True;
           ButSmartKey.bDisabled = False;
           DisplayInfo();
           break;
      case ButSmartKey:
           bSmart = True;
           bVote = False;
           ButSmartKey.bDisabled = True;
           ButVoteKey.bDisabled = False;
           DisplayInfo();
           break;
      case SendButton:
		   if (AdmMessage.GetValue() != "" )
		   {
               GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"AdminMessage "$AdmMessage.GetValue());
			   AdmMessage.SetValue("");
			   AdmMessage.FocusOtherWindow(SendButton);
           }
           break;
      case QuitButton:
           GetPlayerOwner().ConsoleCommand("Exit");
           break;
      case BookButton:
           if (BookButton.bDisabled == false)
               AddToFavourites();
           break;
      case CloseButton:
           ParentWindow.ParentWindow.Close();
           break;
      }
      break;
      case 7:
		   if ( AdmMessage.GetValue() != "" )
		   {
			   GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$sCode$"AdminMessage "$AdmMessage.GetValue());
			   AdmMessage.SetValue("");
			   AdmMessage.FocusOtherWindow(SendButton);
		   }
		   break;
		default:
    }
}

simulated function AddToFavourites()
{
	local int i, j, k;

    j = class'UBrowserFavoritesFact'.default.FavoriteCount;
    if (j >= 99)
    {
        GetPlayerOwner().ClientMessage("Your UT Favourites is currently Full!");
        return;
    }

	for (i=0; i<j; i++) // check to see if already in favs
	{
		k = Instr(class'UBrowserFavoritesFact'.default.Favorites[i],"\\"$ServerIP$"\\"$ServerPort);
		if (k >= 0)
		{
		    GetPlayerOwner().ClientMessage("This server is already in your UT Favourites");
		    return;
	    }
	}

	class'UBrowserFavoritesFact'.default.Favorites[j] = ServerName$"\\"$ServerIP$"\\"$ServerPort$"\\False";
	class'UBrowserFavoritesFact'.default.FavoriteCount = j + 1;
	class'UBrowserFavoritesFact'.SaveConfig();
	class'UBrowserFavoritesFact'.static.StaticSaveConfig();
	GetPlayerOwner().ClientMessage("This server has been added to your UT Favourites");
}

function DisplayInfo()
{
  lblKeyBind.SetText("Press a Key");
}

function LoadExistingKeys()
{
     local int i;
     local string KeyName;
     local string Alias;

     for (i=0; i<255; i++)
     {
          KeyName = GetPlayerOwner().ConsoleCommand( "KEYNAME "$i );
          RealKeyName[i] = KeyName;
          if ( KeyName != "" )
          {
               Alias = GetPlayerOwner().ConsoleCommand( "KEYBINDING "$KeyName );
               if ( Caps(Alias) == "MUTATE BDBMAPVOTE VOTEMENU")
               {
                  ButVoteKey.SetText(KeyName);
                  OldVoteKey = KeyName;
               }

               if ( Caps(Alias) == "MUTATE SMARTDM MENU")
               {
                  ButSmartKey.SetText(KeyName);
                  OldSmartKey = KeyName;
               }
          }
     }
}

function KeyDown( int Key, float X, float Y )
{

   ProcessKey(Key, RealKeyName[Key]);

   bVote  = False;
   ButVoteKey.bDisabled = False;

   bSmart = False;
   ButSmartKey.bDisabled = False;

   lblKeyBind.SetText("");

   ParentWindow.KeyDown(Key, X, Y);
}

function ProcessKey( int KeyNo, string KeyName )
{
     if ( (KeyName == "") || (KeyName == "Escape")
          || ((KeyNo >= 0x70 ) && (KeyNo <= 0x75))  // function keys f1 - f6
          || ((KeyNo >= 0x78 ) && (KeyNo <= 0x7b))  // function keys f9 - f12
          || ((KeyNo >= 0x30 ) && (KeyNo <= 0x39))) // number keys  0 - 9
     {
          return;
     }

     if (bVote)
     {
        SetVoteKey(KeyNo, KeyName);
        return;
     }

     if (bSmart)
     {
        SetSmartKey(KeyNo, KeyName);
        return;
     }
}

function SetVoteKey(int KeyNo, string KeyName)
{
   GetPlayerOwner().ConsoleCommand("SET Input "$KeyName$" MUTATE BDBMAPVOTE VOTEMENU");
   ButVoteKey.SetText(KeyName);
   if (OldVoteKey != "" && OldVoteKey != KeyName) // clear the old key binding
   {
      GetPlayerOwner().ConsoleCommand("SET Input "$OldVoteKey);
   }
}

function SetSmartKey(int KeyNo, string KeyName)
{
   GetPlayerOwner().ConsoleCommand("SET Input "$KeyName$" MUTATE SMARTDM MENU");
   ButSmartKey.SetText(KeyName);
   if (OldSmartKey != "" && OldSmartKey != KeyName) // clear the old key binding
   {
      GetPlayerOwner().ConsoleCommand("SET Input "$OldSmartKey);
   }
}

function Paint (Canvas C, float MouseX, float MouseY)
{
    local Texture MVX;

	Super.Paint(C,MouseX,MouseY);

    MVX = Texture'mvx1';

    DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'grad1');

    C.Style = GetPlayerOwner().ERenderStyle.STY_Translucent;
    C.SetPos( C.ClipX / 2 - MVX.Usize / 2 - 4, 7);
    C.DrawIcon( MVX, 1.0 );
    C.Style = GetPlayerOwner().ERenderStyle.STY_Normal;

    C.DrawColor  = WhiteColor;

    C.Font = Root.Fonts[F_Bold];
    //ClipText(C, 140, 42, "Version "$Version$" - Beta 1"); // beta
    ClipText(C, 158, 42, "Version "$Version);

    C.DrawColor = GrayColor;

    C.Font = Root.Fonts[F_Bold];
    ClipText(C, 138,   60,     "Development & Coding");
    C.Font = Root.Fonts[F_Normal];
    ClipText(C, 176,   75,           "ProAsm");

    ClipText(C, 140,   95,   "Creativity by Back4More");
    ClipText(C, 145,   110,   "Special thanks to BDB");

    C.Font = Root.Fonts[F_Bold];

    ClipText(C, 177,   125,   "Testing");

    C.Font = Root.Fonts[F_Normal];
    C.DrawColor = GrayColor;
    ClipText(C, 153,  140,  "Back4More | Jojoza");
    C.DrawColor = WhiteColor;
    ClipText(C, 141,  160,  "http://www.proasm.com");
}

function Close (optional bool bByParent)
{
	Super.Close(bByParent);
}
//
defaultproperties
{
    GrayColor=(R=128,G=128,B=128)
    WhiteColor=(R=255,G=255,B=255)
}
