//================================================================================
// MapVoteWindowMesg.
//================================================================================
class MapVoteWindowMesg extends UWindowPageWindow;
//

var MapVoteListBox MesgListBox;
var UWindowSmallButton ButDelete;
var UWindowSmallButton ButClose;

var MapVoteGRI MVGRI;

function Created ()
{
	Super.Created();

	MesgListBox=MapVoteListBox(CreateControl(Class'MapVoteListBox',1, 1, 545, 285));
	MesgListBox.Items.Clear();

	ButDelete=UWindowSmallButton(CreateControl(Class'UWindowSmallButton',130, 295, 110, 20));
	ButDelete.DownSound=Sound'GlassTink1';
	ButDelete.Text="Delete All";
	ButDelete.bDisabled=False;

    ButClose=UWindowSmallButton(CreateControl(Class'UWindowSmallButton', 300, 295, 110, 20));
    ButClose.DownSound=Sound'Reload';
    ButClose.Text="Close";
    ButClose.bDisabled=False;
}

function UWindowListBoxItem GetSelectedItem ()
{
	if ( MesgListBox.SelectedItem != None )
		return MesgListBox.SelectedItem;
}

function Notify (UWindowDialogControl C, byte E)
{
    local string sGame;
	local int ListNum, i;

    if ( MVGRI == none )
    {
       foreach Root.GetPlayerOwner().AllActors( class'MapVoteGRI', MVGRI )
       break;
    }

	Super.Notify(C,E);
	switch (E)
	{
		case 1:
		switch (C)
		{
			default:
		}
		break;
		case 2:
		switch (C)
		{
			case ButClose:
			ParentWindow.ParentWindow.Close();
			break;
			case ButDelete:
            ParentWindow.ParentWindow.Close();
            GetPlayerOwner().ConsoleCommand("Mutate MapVoteX "$MVGRI.sCode$"DeleteAdminMessages");
			break;
		default:
		}
	}
}

function Paint (Canvas C, float MouseX, float MouseY)
{
	Super.Paint(C,MouseX,MouseY);

	DrawStretchedTexture(C,0.00,0.00,WinWidth,WinHeight,Texture'grad1');

	C.DrawColor.R=0;
	C.DrawColor.G=0;
	C.DrawColor.B=64;

    DrawStretchedTexture(C, 395, 27, 340, 110, Texture'UnrealShare.NewBlue');
}

function KeyDown (int Key, float X, float Y)
{
	ParentWindow.KeyDown(Key,X,Y);
}

function Close (optional bool bByParent)
{
	local int W;
	local int Mode;

	Super.Close(bByParent);
}
//
