//============================================================================
// MapVoteClientWelcome
//============================================================================
//
class MapVoteClientWelcome extends Info config(MapVoteXL);

var MapVoteX MyMut;
//
struct LogoNames
{
	var bool   bStretch;
	var string LogoName;
	var string SoundName;
};

var() config string WebsiteURL;
var() config string ContactURL;
var() config string AnonymousButtonName;
var() config string AnonymousButtonURL;
var() config bool bUseOnlyWelcomeLogo_0;
var() config LogoNames WelcomeLogo[30];

var bool bInitialized;

function PostBeginPlay ()
{
    Super.PostBeginPlay();

    if ( !bInitialized )
    {
       bInitialized = true;
       SaveConfig();
    }
}

function string GetItem(int iGame, int Item)
{
    local string sTemp;

    sTemp = "";

    if (bUseOnlyWelcomeLogo_0)
        iGame = 0;

    if (Item == 1)
    {
        if (WelcomeLogo[iGame].bStretch)
            sTemp = "1";
        else
            sTemp = "0";
    }
    else
    if (Item == 2)
        sTemp = WelcomeLogo[iGame].LogoName;
    else
    if (Item == 3)
        sTemp = WelcomeLogo[iGame].Soundname;
    else
    if (Item == 4)
        sTemp = WebsiteURL;
    else
    if (Item == 5)
        sTemp = ContactURL;
    else
    if (Item == 6)
        sTemp = AnonymousButtonName;
    else
    if (Item == 7)
        sTemp = AnonymousButtonURL;

    return sTemp;
}
//
defaultproperties
{
}
