//============================================================================
// MapVoteMapLoader
//============================================================================
//
class MapVoteMapLoader extends Info;
//
var MapVoteX MyMut;

var class<MapVoteXMaplist> MapClass;

var string MapList[550];

var string Prefix;
var string FirstMap;
var string NextMap;
var string TestMap;

var int    MapCount, iCount;
var bool   bMapList;
var bool   bStartLoading;

function StartLoadingMaps(string PFix, bool bList, int iGame)
{
    local int i;

    Prefix = PFix;
    bMapList = bList;

    for (i=0; i<550; i++)
         MapList[i] = "";

    MapCount = 0;
    iCount   = 0;

    if (bMapList)
    {
        GetMapListClass(iGame);
    }
    else
    {
	   FirstMap = Level.GetMapName(Prefix,"",0);
	   NextMap = FirstMap;
	   LoadMapTypes();
	}

	bStartLoading = true;
	Enable('Tick');
}

function Tick (float DeltaTime)
{
	Super.Tick(DeltaTime);

    if (bStartLoading)
    {
        if (bMapList)
           LoadMapList();
        else
           LoadMapTypes();
    }
}

function LoadMapTypes()
{
	local string MapName;
	local int z;

	if (FirstMap == TestMap || MapCount >= 500 )
	{
	    bStartLoading = false;
	    Disable('Tick');
	    TransferMaps();
	    MyMut.SortMapsAndGames();
	    return;
	}
	else
	{
		MapName = NextMap;
		z = InStr(Caps(MapName),".UNR");
		if ( z != -1 )
		{
			MapName = Left(MapName,z);
		}
		if ( (InStr(Caps(NextMap),"TUTORIAL") == -1) && (InStr(Caps(NextMap),"INTRO") == -1) )
		{
			if ( MapName != "" )
			{
			    if (MapList[MapCount] != MapName)
			    {
				   MapCount++;
				   MapList[MapCount] = MapName;
				}
			}
		}
		NextMap = Level.GetMapName(Prefix,NextMap,1);
		TestMap = NextMap;
	}
}

//this is crap but cannot find a better way atm
function GetMapListClass(int GameNum)
{
    if (GameNum == 0)
        MapClass = class'MVXCustomGame_00_Maplist';
    if (GameNum == 1)
        MapClass = class'MVXCustomGame_01_Maplist';
    if (GameNum == 2)
        MapClass = class'MVXCustomGame_02_Maplist';
    if (GameNum == 3)
        MapClass = class'MVXCustomGame_03_Maplist';
    if (GameNum == 4)
        MapClass = class'MVXCustomGame_04_Maplist';
    if (GameNum == 5)
        MapClass = class'MVXCustomGame_05_Maplist';
    if (GameNum == 6)
        MapClass = class'MVXCustomGame_06_Maplist';
    if (GameNum == 7)
        MapClass = class'MVXCustomGame_07_Maplist';
    if (GameNum == 8)
        MapClass = class'MVXCustomGame_08_Maplist';
    if (GameNum == 9)
        MapClass = class'MVXCustomGame_09_Maplist';
    if (GameNum == 10)
        MapClass = class'MVXCustomGame_10_Maplist';
    if (GameNum == 11)
        MapClass = class'MVXCustomGame_11_Maplist';
    if (GameNum == 12)
        MapClass = class'MVXCustomGame_12_Maplist';
    if (GameNum == 13)
        MapClass = class'MVXCustomGame_13_Maplist';
    if (GameNum == 14)
        MapClass = class'MVXCustomGame_14_Maplist';
    if (GameNum == 15)
        MapClass = class'MVXCustomGame_15_Maplist';
    if (GameNum == 16)
        MapClass = class'MVXCustomGame_16_Maplist';
    if (GameNum == 17)
        MapClass = class'MVXCustomGame_17_Maplist';
    if (GameNum == 18)
        MapClass = class'MVXCustomGame_18_Maplist';
    if (GameNum == 19)
        MapClass = class'MVXCustomGame_19_Maplist';
    if (GameNum == 20)
        MapClass = class'MVXCustomGame_20_Maplist';
    if (GameNum == 21)
        MapClass = class'MVXCustomGame_21_Maplist';
    if (GameNum == 22)
        MapClass = class'MVXCustomGame_22_Maplist';
    if (GameNum == 23)
        MapClass = class'MVXCustomGame_23_Maplist';
    if (GameNum == 24)
        MapClass = class'MVXCustomGame_24_Maplist';
    if (GameNum == 25)
        MapClass = class'MVXCustomGame_25_Maplist';
    if (GameNum == 26)
        MapClass = class'MVXCustomGame_26_Maplist';
    if (GameNum == 27)
        MapClass = class'MVXCustomGame_27_Maplist';
    if (GameNum == 28)
        MapClass = class'MVXCustomGame_28_Maplist';
    if (GameNum == 29)
        MapClass = class'MVXCustomGame_29_Maplist';
}

function LoadMapList()
{
    local string sTemp;
    local int j;

    if (MapClass.default.Map[iCount] == "" || iCount >= 200)
    {
	    bStartLoading = false;
	    Disable('Tick');
	    TransferMaps();
	    MyMut.SortMapsAndGames();
	    return;
    }
    else
    {
        sTemp = MapClass.default.Map[iCount];
        j = InStr(Caps(sTemp),"TUTORIAL");
        if (j == -1)
        {
           j = InStr(sTemp, ".unr");
           if (j >= 0)
               sTemp = Left(sTemp, j);
           MapCount++;
           MapList[MapCount] = sTemp;
        }
        iCount++;
    }
}

function TransferMaps()
{
    local int i;

    MyMut.MapCount = MapCount;

    for (i=0; i<MapCount+1; i++)
    {
         MyMut.MapList[i] = MapList[i];
    }
}
//
defaultproperties
{
}
