//==============================================================================
// MapVote Message Windows ReplicationInfo.
//==============================================================================
//
class  MapVoteMessageWRI extends MapVoteWRI;
//
var string sCode;
var string MesgList[101];

var int repMesgListCountX, LastMesgListCountX, LastMesgCount;

replication
{
   reliable if ( Role == ROLE_Authority )
            MesgList, sCode;
}

event PostBeginPlay()
{
    bAdminMesg = true;
	Super.PostBeginPlay();
}

simulated function Timer ()
{
	local int repMesgCount;
	local int repMesgListCountX;
	local string sTemp;
	local int i, j;

	if ( !bOpenWindowDispatched )
	{
		OpenWindow();
		return;
	}
	if ( !bSetupWindowDelayDone )
	{
		bSetupWindowDelayDone=True;
		SetupWindow();
	    MapVoteTabWindow(TheWindow).SetupMapWindow(true, 1, 0, 0, 0, 0, 0, "");
	}

    MapVoteTabWindow(TheWindow).SetupMenu("", sCode, 0, "", "", "", "");
    bUpdated = False;

	for (i=1; i<101; i++)
	{
		if (MesgList[i] == "")
		   break;
		repMesgListCountX++;
	}

    j = 1;
	if ( repMesgListCountX > LastMesgListCountX )
	{
		MapVoteTabWindow(TheWindow).ClearMesgs();
		for (i=1; i<101; i++)
		{
		    sTemp = MesgList[i];
		    if (sTemp != "")
		    {
		        MapVoteTabWindow(TheWindow).AddMessage(sTemp);
		    }
		}
		LastMesgListCountX = repMesgListCountX;
		bUpdated=True;
	}

	repMesgCount = repMesgListCountX + repMesgListCountX;
	if ( repMesgCount > LastMesgCount )
	{
		bUpdated = True;
		LastMesgCount = repMesgCount;
	}

	if ( !bUpdated )
	{
		blastCheck = True;
		SetTimer(1.00,False);
		return;
	}

	blastCheck = False;
	SetTimer(0.50,False);
}
//
defaultproperties
{
    WinWidth=550
}